﻿#include "TestTableModel.h"

TestTableModel::TestTableModel(QObject* parent)
	: QAbstractItemModel(parent)
{
}

QVariant TestTableModel::headerData(int section, Qt::Orientation orientation, int role) const
{
	// FIXME: Implement me!
	return {};
}

bool TestTableModel::setHeaderData(int section, Qt::Orientation orientation, const QVariant& value, int role)
{
	if (value != headerData(section, orientation, role)) {
		// FIXME: Implement me!
		emit headerDataChanged(orientation, section, section);
		return true;
	}
	return false;
}

QModelIndex TestTableModel::index(int row, int column, const QModelIndex& parent) const
{
	if (hasIndex(row, column, parent)) {
		return createIndex(row, column, row);
	}
	return {};
}

QModelIndex TestTableModel::parent(const QModelIndex& index) const
{
	// FIXME: Implement me!
	return {};
}

int TestTableModel::rowCount(const QModelIndex& parent) const
{
	return 10000;
}

int TestTableModel::columnCount(const QModelIndex& parent) const
{
	return 15;
}

bool TestTableModel::hasChildren(const QModelIndex& parent) const
{
	// FIXME: Implement me!
	return false;
}

bool TestTableModel::canFetchMore(const QModelIndex& parent) const
{
	// FIXME: Implement me!
	return false;
}

void TestTableModel::fetchMore(const QModelIndex& parent)
{
	// FIXME: Implement me!
}

QVariant TestTableModel::data(const QModelIndex& index, int role) const
{
	if (!index.isValid()) {
		return {};
	}
	return 1;
}

bool TestTableModel::setData(const QModelIndex& index, const QVariant& value, int role)
{
	if (data(index, role) != value) {
		// FIXME: Implement me!
		emit dataChanged(index, index, QVector<int>() << role);
		return true;
	}
	return false;
}

Qt::ItemFlags TestTableModel::flags(const QModelIndex& index) const
{
	if (!index.isValid()) {
		return Qt::NoItemFlags;
	}

	return Qt::ItemIsEditable;   // FIXME: Implement me!
}

bool TestTableModel::insertRows(int row, int count, const QModelIndex& parent)
{
	beginInsertRows(parent, row, row + count - 1);
	// FIXME: Implement me!
	endInsertRows();
	return false;
}

bool TestTableModel::insertColumns(int column, int count, const QModelIndex& parent)
{
	beginInsertColumns(parent, column, column + count - 1);
	// FIXME: Implement me!
	endInsertColumns();
	return false;
}

bool TestTableModel::removeRows(int row, int count, const QModelIndex& parent)
{
	beginRemoveRows(parent, row, row + count - 1);
	// FIXME: Implement me!
	endRemoveRows();
	return false;
}

bool TestTableModel::removeColumns(int column, int count, const QModelIndex& parent)
{
	beginRemoveColumns(parent, column, column + count - 1);
	// FIXME: Implement me!
	endRemoveColumns();
	return false;
}

QHash<int, QByteArray> TestTableModel::roleNames() const
{
	QHash<int, QByteArray> rn;
	rn.insert(Qt::UserRole, QByteArrayLiteral("modelData"));
	return rn;
}
